/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.31 by edhill, Wed Nov 12 21:14:57 2003 UTC revision 1.58 by afe, Fri Jan 9 22:08:39 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
86            
87      echo "test" > test      echo "test" > test
88      ln -s ./test link      ln -s ./test link
# Line 104  find_possible_configs()  { Line 100  find_possible_configs()  {
100          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
101      fi      fi
102    
103        # makedepend is not always available
104        if test "x${MAKEDEPEND}" = x ; then
105          which makedepend >& /dev/null
106          RETVAL=$?
107          if test "x${RETVAL}" = x1 ; then
108             echo "    makedepend was not found. Using xmakedpend instead."
109             MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
110          fi
111        fi
112    
113      # look for possible fortran compilers      # look for possible fortran compilers
114      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
115      p_FC=      p_FC=
# Line 206  get_pdepend_list()  { Line 212  get_pdepend_list()  {
212      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
213          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
214          > ./.pd_tmp          > ./.pd_tmp
215      source ./.pd_tmp      . ./.pd_tmp
216      rm -f ./.pd_tmp      rm -f ./.pd_tmp
217    
218      echo -n "PNAME = "${}      echo -n "PNAME = "${}
# Line 215  get_pdepend_list()  { Line 221  get_pdepend_list()  {
221    
222  #  Explain usage  #  Explain usage
223  usage()  {  usage()  {
224      echo  cat <<EOF
225      echo "Usage: "$0" [OPTIONS]"  
226      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
227      echo    where [OPTIONS] can be:
228      echo "    -help | --help | -h | --h"  
229      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
230      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
231      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
232      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
233      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
234      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
235      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
236      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
237      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
238      echo "    -makefile NAME | -mf NAME"  
239      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
240      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
241      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
242      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
243      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
244      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
245      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
246      echo "    -disable NAME | --disable NAME"  
247      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
248      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
249      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
250      echo "    -standarddirs NAME | --standarddirs NAME"            many platforms, "gmake" is the preferred choice.
251      echo "      -standarddirs=NAME | --standarddirs=NAME"  
252      echo "    -noopt NAME | --noopt NAME"      -makefile NAME | -mf NAME
253      echo "      -noopt=NAME | --noopt=NAME"        --makefile=NAME | -mf=NAME
254  #    echo "    -cpp NAME | --cpp NAME"            Call the makefile "NAME".  The default is "Makefile".
255  #    echo "      -cpp=NAME | --cpp=NAME"  
256      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
257      echo "      -fc=NAME | --fc=NAME"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
258      echo "    -[no]ieee | --[no]ieee"            Specify the location of the MITgcm ROOTDIR as "NAME".
259      echo "    -[no]mpi | --[no]mpi"            By default, genamke will try to find the location by
260      echo "    -[no]jam | --[no]jam"            looking in parent directories (up to the 5th parent).
261      echo  
262      echo "  and NAME is a string such as:"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
263      echo        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
264      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"            Here, "NAME" specifies a list of directories that are
265      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"            used for additional source code.  Files found in the
266      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"            "mods list" are given preference over files of the same
267      echo            name found elsewhere.
268      echo "  which, depending upon your shell, may need to be single-quoted"  
269      echo "  if it contains spaces, dashes, or other special characters."      -disable NAME | --disable NAME
270          -disable=NAME | --disable=NAME
271              Here "NAME" specifies a list of packages that we don't
272              want to use.  If this violates package dependencies,
273              genamke will exit with an error message.
274    
275        -enable NAME | --enable NAME
276          -enable=NAME | --enable=NAME
277              Here "NAME" specifies a list of packages that we wish
278              to specifically enable.  If this violates package
279              dependencies, genamke will exit with an error message.
280    
281        -standarddirs NAME | --standarddirs NAME
282          -standarddirs=NAME | --standarddirs=NAME
283              Here, "NAME" specifies a list of directories to be
284              used as the "standard" code.
285    
286        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
287          -fc=NAME | --fc=NAME
288              Use "NAME" as the fortran compiler.  By default, genmake
289              will search for a working compiler by trying a list of
290              "usual suspects" such as g77, f77, etc.
291    
292        -[no]ieee | --[no]ieee
293              Do or don't use IEEE numerics.  Note that this option
294              *only* works if it is supported by the OPTFILE that
295              is being used.
296    
297      While it is most often a single word, the "NAME" variables specified
298      above can in many cases be a space-delimited string such as:
299    
300        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
301        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
302        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
303    
304      which, depending upon your shell, may need to be single-quoted.
305    
306      For more detailed genmake documentation, please see:
307    
308        http://mitgcm.org/devel_HOWTO/
309    
310    EOF
311    
312      exit 1      exit 1
313  }  }
314    
# Line 271  get_fortran_c_namemangling()  { Line 319  get_fortran_c_namemangling()  {
319      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
320  void tcall( char * string ) { tsub( string ); }  void tcall( char * string ) { tsub( string ); }
321  EOF  EOF
322      $MAKE genmake_test.o > genmake_test.log 2>&1      $MAKE genmake_test.o >> genmake_warnings 2>&1
323      RETVAL=$?      RETVAL=$?
324      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
         cat genmake_test.log >> genmake_errors  
325          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
326          echo          cat <<EOF>> genmake_errors
327          echo "WARNING: C test compile fails -- please see \"genmake_errors\""  
328          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: C test compile fails
329          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
330    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
331    EOF
332          return 1          return 1
333      fi      fi
334      c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
335      RETVAL=$?      RETVAL=$?
336      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
337          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
338          echo          cat <<EOF>> genmake_warnings
339          echo "WARNING: The \"nm\" command failed."  
340          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: The "nm" command failed.
341          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
342    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
343    EOF
344          return 1          return 1
345      fi      fi
346      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.f <<EOF
# Line 298  EOF Line 349  EOF
349        call tsub( string )        call tsub( string )
350        end        end
351  EOF  EOF
352      $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
353      RETVAL=$?      RETVAL=$?
354      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
         cat genmake_tcomp.log >> genmake_errors  
355          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
356          echo          cat <<EOF>> genmake_warnings
357          echo "WARNING: FORTRAN test compile fails -- please see \"genmake_errors\""  
358          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: FORTRAN test compile fails -- please see "genmake_errors"
359          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
360    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
361    EOF
362          return 1          return 1
363      fi      fi
364      f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
365      RETVAL=$?      RETVAL=$?
366      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
367          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
368          echo          cat <<EOF>> genmake_warnings
369          echo "WARNING: The \"nm\" command failed."  
370          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: The "nm" command failed.
371          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
372    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
373    EOF
374          return 1          return 1
375      fi      fi
376    
# Line 338  EOF Line 392  EOF
392      fi      fi
393    
394      FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"      FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
395    
396        #  cleanup the testing files
397        rm -f genmake_tcomp.* genmake_test.*
398    }
399    
400    
401    check_HAVE_CLOC()  {
402        get_fortran_c_namemangling
403        cat <<EOF > genmake_tc_1.c
404    $FC_NAMEMANGLE
405    #include <stdio.h>
406    #include <stdlib.h>
407    #include <unistd.h>
408    #include <assert.h>
409    #include <sys/time.h>
410    void FC_NAMEMANGLE(cloc) ( double *curtim )
411    {
412     struct timeval tv1;
413     gettimeofday(&tv1 , (void *)NULL );
414     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
415     *curtim = *curtim/1.E6;
416    }
417    EOF
418        make genmake_tc_1.o >> genmake_tc.log 2>&1
419        RET_C=$?
420        cat <<EOF > genmake_tc_2.f
421          program hello
422          Real*8 wtime
423          external cloc
424          call cloc(wtime)
425          print *," HELLO WORLD", wtime
426          end program hello
427    EOF
428        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
429        RET_F=$?
430        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
431        RETVAL=$?
432        if test "x$RETVAL" = x0 ; then
433            HAVE_CLOC=t
434            DEFINES="$DEFINES -DHAVE_CLOC"
435        fi
436        rm -f genmake_tc*
437  }  }
438    
439    
440  #  Set defaults here  #  Set defaults here
441  COMMANDL="$0 $@"  COMMANDL="$0 $@"
442    
# Line 375  NOOPTFLAGS= Line 472  NOOPTFLAGS=
472  HAVE_SYSTEM=  HAVE_SYSTEM=
473  HAVE_FDATE=  HAVE_FDATE=
474  FC_NAMEMANGLE=  FC_NAMEMANGLE=
475    HAVE_CLOC=
476    
477  MODS=  MODS=
478  TOOLSDIR=  TOOLSDIR=
479  SOURCEDIRS=  SOURCEDIRS=
480  INCLUDEDIRS=  INCLUDEDIRS=
481  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
482    
483  PWD=`pwd`  PWD=`pwd`
484  MAKE=make  MAKE=make
# Line 413  TAMC_EXTRA= Line 511  TAMC_EXTRA=
511    
512    
513  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
514  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
515  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
516    
517  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
# Line 431  gm_s12="TAF_EXTRA TAMC_EXTRA" Line 529  gm_s12="TAF_EXTRA TAMC_EXTRA"
529  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
530  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
531    
532    cat <<EOF
533    
534    GENMAKE :
535    
536    A program for GENerating MAKEfiles for the MITgcm project.  For a
537    quick list of options, use "genmake -h" or for more detail see:
538    
539      http://mitgcm.org/devel_HOWTO/
540    
541    EOF
542    
 echo  
543  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
544  gm_local="genmake_local"  gm_local="genmake_local"
545  for i in . $MODS ; do  for i in . $MODS ; do
546      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
547          source $i/$gm_local          . $i/$gm_local
548          break          break
549      fi      fi
550  done  done
551  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
552  if test -e $gm_local ; then  if test -e $gm_local ; then
553      echo "using $gm_local"      echo "using $gm_local"
554      source $gm_local      . $gm_local
555      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
556      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
557  else  else
# Line 486  for ac_option ; do Line 593  for ac_option ; do
593          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
594              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
595                    
596          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
597              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
598          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
599              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 511  for ac_option ; do Line 618  for ac_option ; do
618          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
619              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
620                    
621          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
622              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
623          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
624              PLATFORM=$ac_optarg ;;              echo
625                usage
626                ;;
627                    
628          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
629              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 541  for ac_option ; do Line 650  for ac_option ; do
650          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
651              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
652    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
653  #           -cpp | --cpp)  #           -cpp | --cpp)
654  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
655  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 561  for ac_option ; do Line 665  for ac_option ; do
665          -noieee | --noieee)          -noieee | --noieee)
666              IEEE= ;;              IEEE= ;;
667                    
668          -mpi | --mpi)  #       -jam | --jam)
669              MPI=true ;;  #           JAM=1 ;;
670          -nompi | --nompi)  #       -nojam | --nojam)
671              MPI= ;;  #           JAM=0 ;;
           
         -jam | --jam)  
             JAM=1 ;;  
         -nojam | --nojam)  
             JAM=0 ;;  
672                    
673          -ds | --ds)          -ds | --ds)
674              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 648  fi Line 747  fi
747  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
748      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
749          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
750          source "$OPTFILE"          . "$OPTFILE"
751          RETVAL=$?          RETVAL=$?
752          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
753              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
# Line 675  fi Line 774  fi
774  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
775      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
776          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
777          source "$AD_OPTFILE"          . "$AD_OPTFILE"
778          RETVAL=$?          RETVAL=$?
779          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
780              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
# Line 691  if test "x${AD_OPTFILE}" != xNONE ; then Line 790  if test "x${AD_OPTFILE}" != xNONE ; then
790      fi      fi
791  fi  fi
792    
793  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
794  #  and abort!  #  either set defaults or complain and abort!
795  if test "x$FC" = x ; then  if test "x$FC" = x ; then
796      cat <<EOF 1>&2      cat <<EOF 1>&2
797    
# Line 709  fi Line 808  fi
808  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
809      CPP="cpp"      CPP="cpp"
810  fi  fi
811    if test "x$MAKE" = x ; then
812        MAKE="make"
813    fi
814  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
815  RETVAL=$?  RETVAL=$?
816  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 728  fi Line 830  fi
830  if test "x$MAKEDEPEND" = x ; then  if test "x$MAKEDEPEND" = x ; then
831      MAKEDEPEND=makedepend      MAKEDEPEND=makedepend
832  fi  fi
833    if test "x$LN" = x ; then
834        LN="ln -s"
835    fi
836    echo "test" > genmake_test_ln
837    $LN genmake_test_ln genmake_tlink
838    RETVAL=$?
839    if test "x$RETVAL" != x0 ; then
840        cat <<EOF 1>&2
841    
842    Error: The command "ln -s" failed -- please specify a working soft-link
843      command in the optfile.
844    
845    EOF
846        exit 1
847    fi
848    rm -f genmake_test_ln genmake_tlink
849    
850    
851  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
# Line 770  else Line 888  else
888  fi  fi
889  rm -f genmake_tcomp*  rm -f genmake_tcomp*
890    
891  echo "  The name mangling convention for $FC is...  "  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
892  #FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"  check_HAVE_CLOC
893  if test "x$FC_NAMEMANGLE" = x ; then  if test "x$HAVE_CLOC" != x ; then
894      get_fortran_c_namemangling      echo "yes"
895  fi  else
896  echo "    '$FC_NAMEMANGLE'"      echo "no"
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
897  fi  fi
898    rm -f genmake_t*
899    
900    
901  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 828  fi Line 942  fi
942  if test "x$S64" = x ; then  if test "x$S64" = x ; then
943      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
944  fi  fi
945    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
946    
947  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
948    
# Line 836  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 951  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
951  #  they appear as regular source code  #  they appear as regular source code
952  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
953      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
954      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
955      RETVAL=$?      RETVAL=$?
956      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
957          rm -f make_eesupp.errors          rm -f make_eesupp.errors
# Line 847  if test -r $ROOTDIR"/eesupp/src/Makefile Line 962  if test -r $ROOTDIR"/eesupp/src/Makefile
962      fi      fi
963  fi  fi
964    
965    #same for exch2
966    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
967        echo "  Making source files in exch2 from  templates"
968        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
969        RETVAL=$?
970        if test "x${RETVAL}" = x0 ; then
971            rm -f make_exch2.errors
972        else
973            echo "Error: problem encountered while building source files in exch2:"        cat make_exch2.errors
974            exit 1
975        fi
976    fi
977    
978  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
979  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
980      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 873  if test ! "x${RETVAL}" = x0 ; then Line 1001  if test ! "x${RETVAL}" = x0 ; then
1001      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1002      exit 1      exit 1
1003  fi  fi
1004  source ./.pd_tmp  . ./.pd_tmp
1005  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1006    
1007  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1008  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1009  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1010  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1011  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1012      for i in "." $MODS ; do      for i in "." $MODS ; do
1013          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 892  if test "x${PDEFAULT}" = x ; then Line 1020  if test "x${PDEFAULT}" = x ; then
1020      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1021  fi  fi
1022  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1023      echo "default packages file disabled"      echo "    default packages file disabled"
1024  else  else
1025      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1026          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1027      else      else
1028          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1029          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1030          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1031          RETVAL=$?          RETVAL=$?
# Line 1034  done Line 1161  done
1161    
1162  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1163  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
   
 C  Packages disabled by genmake:  
 EOF  
1164  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1165  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1166  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1167  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1168  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1169  all_pack=  all_pack=
1170    DISABLED_PACKAGES=
1171  for n in $names ; do  for n in $names ; do
1172      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1173          has_pack="f"          has_pack="f"
# Line 1063  for n in $names ; do Line 1179  for n in $names ; do
1179          done          done
1180          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1181              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1182              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1183          fi          fi
1184      fi      fi
1185  done  done
1186  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1187  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1188      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1189      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1190  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1191    
1192  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1193      case $i in      case $i in
1194          aim_v23)          aim_v23)
1195              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1196              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1197              ;;              ;;
1198      esac      esac
1199  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1200    
1201  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1202    
1203  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1204  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1205  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1206      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1207  fi  fi
1208  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1209      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1210      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1211          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1212          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1213          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1214      else              exit 1
1215          SOURCEDIRS="$SOURCEDIRS $adr"          else
1216      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1217      adr="$ROOTDIR/$d/inc"          fi
1218      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1219          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1220          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1221          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1222      else              exit 1
1223          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1224      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1225  done          fi
1226        done
1227    fi
1228    
1229  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1230  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1231  CPP_OPTIONS=  CPP_OPTIONS=
1232    CPP_EEOPTIONS=
1233  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1234    names=`ls -1 "$ROOTDIR/pkg"`
1235  for i in $spaths ; do  for i in $spaths ; do
1236      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1237      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1238          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1239          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1240          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1241            for n in $names ; do
1242                test_for_package_in_cpp_options $CPP_OPTIONS $n
1243            done
1244        fi
1245        try="$i/CPP_EEOPTIONS.h"
1246        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1247            echo "    found CPP_EEOPTIONS=\"$try\""
1248            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1249    #**** not yet enabled ****
1250    #        test_for_mpi_in_cpp_eeoptions $try
1251    #**** not yet enabled ****
1252            CPP_EEOPTIONS="$try"
1253      fi      fi
1254  done  done
1255  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1256      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1257      exit 1      exit 1
1258  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1259    
1260  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1261  #  compiler.  #  compiler.
# Line 1166  for i in $SOURCEDIRS ; do Line 1270  for i in $SOURCEDIRS ; do
1270      done      done
1271  done  done
1272    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
   
1273  echo  echo
1274  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1275  echo "  setting INCLUDES"  echo "  setting INCLUDES"
# Line 1207  for d in $alldirs ; do Line 1299  for d in $alldirs ; do
1299      for sf in $sfiles ; do      for sf in $sfiles ; do
1300          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1301              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1302                    case $d/$sf in
1303                      ./$PACKAGES_DOT_H)
1304                            ;;
1305                      ./AD_CONFIG.h)
1306                            ;;
1307                      ./FC_NAMEMANGLE.h)
1308                            ;;
1309                      *)
1310                            touch .links.tmp/$sf
1311                            deplist="$deplist $sf"
1312                            ;;
1313                    esac
1314                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1315                  case $extn in                  case $extn in
1316                      F)                      F)
1317                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
# Line 1267  EXE_FTL=$EXECUTABLE"_ftl" Line 1369  EXE_FTL=$EXECUTABLE"_ftl"
1369  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1370    
1371  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1372    #
1373    # OPTFILE="$OPTFILE"
1374  #  #
1375  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1376  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1300  EXE_AD      = ${EXE_AD} Line 1404  EXE_AD      = ${EXE_AD}
1404  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1405  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1406    
1407    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1408    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1409    
1410    # These files are created by Makefile
1411    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1412    
1413  EOF  EOF
1414    
1415  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1364  cat >>$MAKEFILE <<EOF Line 1474  cat >>$MAKEFILE <<EOF
1474  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1475    
1476  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1477  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1478            @echo Creating \$@ ...
1479          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1480  depend:  depend:
1481          @make links          @make links
1482          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1483          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1484    
1485  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1486    
1487  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1488    
# Line 1380  output.txt: \$(EXECUTABLE) Line 1491  output.txt: \$(EXECUTABLE)
1491          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1492    
1493  clean:  clean:
1494          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1495  Clean:  Clean:
1496          @make clean          @make clean
1497          @make cleanlinks          @make cleanlinks
1498          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1499            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1500  CLEAN:  CLEAN:
1501          @make Clean          @make Clean
1502          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1395  CLEAN: Line 1506  CLEAN:
1506    
1507  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1508  makefile:  makefile:
1509          ${0} $@          $THIS_SCRIPT $@
1510  cleanlinks:  cleanlinks:
1511          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1512    
1513    # Special targets ($SPECIAL_FILES) which are create by make
1514    ${PACKAGES_DOT_H}:
1515            @echo Creating \$@ ...
1516            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1517    AD_CONFIG.h:
1518            @echo Creating \$@ ...
1519            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1520    FC_NAMEMANGLE.h:
1521            @echo Creating \$@ ...
1522            echo "$FC_NAMEMANGLE" > \$@
1523    
1524  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1525  .F.f:  .F.f:
1526          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1458  adtaf: ad_taf_output.f Line 1580  adtaf: ad_taf_output.f
1580  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1581    
1582  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1583            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1584          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1585            -rm -f ad_config.template
1586          @make \$(F77FILES)          @make \$(F77FILES)
1587          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1588          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1589    
1590  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1591          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1592          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1593    
1594    adtafonly:
1595            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1596            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1597    
1598  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1599          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1600    
1601  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1602          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1603          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1604    
1605  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1606          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1484  ftltaf: ftl_taf_output.f Line 1612  ftltaf: ftl_taf_output.f
1612  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1613    
1614  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1615            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1616          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1617            -rm -f ftl_config.template
1618          @make \$(F77FILES)          @make \$(F77FILES)
1619          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1620          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1621    
1622  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1623          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1624          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1625    
1626    ftltafonly:
1627            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1628            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1629    
1630  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1631          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1632    
1633  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1634          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1635          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1636    
1637  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1638          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1639    
1640    
1641  # ... SVD ...  # ... SVD ...
1642  svd: svd_taf  svdtaf: ad_taf_output.f ftl_taf_output.f
1643  svd_taf_f: svd_taf_output.f  svdall: svd_taf
   
 svd_input_code.f: \$(SRCFILES)  
         cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h  
         @make \$(F77FILES)  
         @make \$(AD_FLOW_FILES)  
         cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f  
1644    
1645  svd_taf_output.f: svd_input_code.f  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1646          \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
         cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
   
 svd_taf: svd_taf_output.o \$(OBJFILES)  
         \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)  
1647    
1648    
1649  #=========================================  #=========================================
# Line 1560  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1684  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1684    
1685  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1686    
1687  #  Write the "template" files for the adjoint builds  # Create special header files
1688  cat >AD_CONFIG.template <<EOF  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1689  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
1690  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1691  C    unless you are CERTAIN that you know what you are doing.  else
1692        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1693  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
1694  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
1695  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
1696  EOF      else
1697  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1698  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1699  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
1700  C    unless you are CERTAIN that you know what you are doing.  fi
1701    if test ! -f AD_CONFIG.h ; then
1702  #define ALLOW_ADJOINT_RUN      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1703  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
1704    
1705    
1706  #  Write the "state" for future records  #  Write the "state" for future records

Legend:
Removed from v.1.31  
changed lines
  Added in v.1.58

  ViewVC Help
Powered by ViewVC 1.1.22